unit hiEnumProcess; {     Windows  NT }

interface

uses Windows,Messages,Kol,Share,tlhelp32,Debug;

const     
   NORMAL_PRIORITY_CLASS       = $00000020;
   IDLE_PRIORITY_CLASS         = $00000040;
   HIGH_PRIORITY_CLASS         = $00000080;
   REALTIME_PRIORITY_CLASS     = $00000100;
   BELOW_NORMAL_PRIORITY_CLASS = $00004000;
   ABOVE_NORMAL_PRIORITY_CLASS = $00008000;
   PROCES_WOW64_INFORMATION    = 26;
   PROCESS_IMAGE_FILE_NAME     = 27;
   RELEASE_COMPONENT           ='EnumProcess_013';

type
   PPSID = ^PSID;
   PPACL = ^PACL;
   SIZE_T = LONGWORD;
   NTStatus = DWORD;

type
  PUnicodeString = ^TUnicodeString;
  TUnicodeString = packed record
    Length: Word;
    MaximumLength: Word;
    Buffer: PWideChar;
  end;

type
  PObjectAttributes = ^TObjectAttributes;
  TObjectAttributes = packed record
    Length: DWORD;
    RootDirectory: THandle;
    ObjectName: PUnicodeString;
    Attributes: DWORD;
    SecurityDescriptor: Pointer;
    SecurityQualityOfService: Pointer;
  end;

type
  PClientID = ^TClientID;
  TClientID = packed record
    UniqueProcess:cardinal;
    UniqueThread:cardinal;
  end;

type
  PPROCESS_BASIC_INFORAMTION = ^PROCESS_BASIC_INFORAMTION;
  PROCESS_BASIC_INFORAMTION = packed record
    ExitStatus : DWORD;
    PEBBaseAddress : Pointer;
    AffinityMask : DWORD;
    BasePriority : DWORD;
    UniqueProcessId : DWORD;
    InheritedFormUniqueProcessId : DWORD;
  end;

type
  PPROCESS_MEMORY_COUNTERS = ^PROCESS_MEMORY_COUNTERS;
  _PROCESS_MEMORY_COUNTERS = packed record
    cb: DWORD;
    PageFaultCount: DWORD;
    PeakWorkingSetSize: SIZE_T;
    WorkingSetSize: SIZE_T;
    QuotaPeakPagedPoolUsage: SIZE_T;
    QuotaPagedPoolUsage: SIZE_T;
    QuotaPeakNonPagedPoolUsage: SIZE_T;
    QuotaNonPagedPoolUsage: SIZE_T;
    PagefileUsage: SIZE_T;
    PeakPagefileUsage: SIZE_T;
  end;
  PROCESS_MEMORY_COUNTERS = _PROCESS_MEMORY_COUNTERS;
  TProcessMemoryCounters = PROCESS_MEMORY_COUNTERS;
  PProcessMemoryCounters = PPROCESS_MEMORY_COUNTERS;

type 
  PPerfDataBlock = ^TPerfDataBlock; 
  TPerfDataBlock = record 
    Signature: array[0..3] of WCHAR; 
    LittleEndian: DWORD; 
    Version: DWORD; 
    Revision: DWORD; 
    TotalByteLength: DWORD; 
    HeaderLength: DWORD; 
    NumObjectTypes: DWORD; 
    DefaultObject: Longint; 
    SystemTime: TSystemTime; 
    PerfTime: TLargeInteger; 
    PerfFreq: TLargeInteger; 
    PerfTime100nSec: TLargeInteger; 
    SystemNameLength: DWORD; 
    SystemNameOffset: DWORD; 
  end; 

  PPerfObjectType = ^TPerfObjectType; 
  TPerfObjectType = record 
    TotalByteLength: DWORD; 
    DefinitionLength: DWORD; 
    HeaderLength: DWORD; 
    ObjectNameTitleIndex: DWORD; 
    ObjectNameTitle: LPWSTR; 
    ObjectHelpTitleIndex: DWORD; 
    ObjectHelpTitle: LPWSTR; 
    DetailLevel: DWORD; 
    NumCounters: DWORD; 
    DefaultCounter: Longint; 
    NumInstances: Longint; 
    CodePage: DWORD; 
    PerfTime: TLargeInteger; 
    PerfFreq: TLargeInteger; 
  end; 

  PPerfCounterDefinition = ^TPerfCounterDefinition; 
  TPerfCounterDefinition = record 
    ByteLength: DWORD; 
    CounterNameTitleIndex: DWORD; 
    CounterNameTitle: LPWSTR; 
    CounterHelpTitleIndex: DWORD; 
    CounterHelpTitle: LPWSTR; 
    DefaultScale: Longint; 
    DetailLevel: DWORD; 
    CounterType: DWORD; 
    CounterSize: DWORD; 
    CounterOffset: DWORD; 
  end; 

  PPerfInstanceDefinition = ^TPerfInstanceDefinition; 
  TPerfInstanceDefinition = record 
    ByteLength: DWORD; 
    ParentObjectTitleIndex: DWORD; 
    ParentObjectInstance: DWORD; 
    UniqueID: Longint; 
    NameOffset: DWORD; 
    NameLength: DWORD; 
  end; 

  PPerfCounterBlock = ^TPerfCounterBlock; 
  TPerfCounterBlock = record 
    ByteLength: DWORD; 
  end;

type
  PROCESS_BASIC_INFORMATION = packed record
    ExitStatus: DWORD;
    PebBaseAddress: Pointer;
    AffinityMask: DWORD;
    BasePriority: DWORD;
    uUniqueProcessId: Ulong;
    uInheritedFromUniqueProcessId: Ulong;
  end;
  
type
   TCB = function: boolean of object;
   ThiEnumProcess = class(TDebug)
   private
      DebugPrivilege: boolean;
      ID: Cardinal;
      PName, FFullPath: string;
      ovi: TOSVersionInfo;
      procEntry:PROCESSENTRY32;
      procedure Enum(CallBack:TCB);
      procedure EnumNT(CallBack:TCB);
      function EnumAll: boolean;
      function FindID: boolean;
      function FindName: boolean;
   public
      _prop_Name: string;
      _prop_TimeOut:integer;
      _data_ID:THI_Event;
      _data_Name:THI_Event;
      _data_AffinityMask:THI_Event;
      _data_PriorityBoost:THI_Event;
      _data_PriorityClass:THI_Event;
      _event_onProcess:THI_Event;
      _event_onTerminateApp:THI_Event;
      _event_onGetPriority:THI_Event;
      _event_onGetProc:THI_Event;
      _event_onGetProcBoost:THI_Event;
      _event_onGetMemoryInfo:THI_Event;
      _event_onGetProcessAccount:THI_Event;
      _event_onFind:THI_Event;
      _event_onNotFind:THI_Event;
      _event_onEndEnum:THI_Event;

   constructor Create;
   property  _prop_DebugPrivilege:boolean write DebugPrivilege;
   procedure _work_doDebugPrivilege(var _Data:TData; Index:word);
   procedure _work_doEnum(var _Data:TData; Index:word);
   procedure _work_doFindID(var _Data:TData; Index:word);
   procedure _work_doFindName(var _Data:TData; Index:word);
   procedure _work_doKill(var _Data:TData; Index:word);
   procedure _work_doTerminateApp(var _Data:TData; Index:word);   
   procedure _work_doSetPriority(var _Data:TData; Index:word);
   procedure _work_doSetProc(var _Data:TData; Index:word);
   procedure _work_doSetProcBoost(var _Data:TData; Index:word);
   procedure _work_doGetPriority(var _Data:TData; Index:word);
   procedure _work_doGetMemoryInfo(var _Data:TData; Index:word);
   procedure _work_doGetProcessAccount(var _Data:TData; Index:word);
   procedure _work_doGetProc(var _Data:TData; Index:word);
   procedure _work_doGetProcBoost(var _Data:TData; Index:word);
   procedure _var_CurrentID(var _Data:TData; Index:word);
   procedure _var_CurrParentID(var _Data:TData; Index:word);   
   procedure _var_FileName(var _Data:TData; Index:word);
   procedure _var_CPUCount(var _Data:TData; Index:word);
   procedure _var_FullPath(var _Data:TData; Index:word);
   procedure _var_Release(var _Data:TData; Index:word);      
end;

function GetProcessPriorityBoost(hThread: THandle; var DisablePriorityBoost: Bool): BOOL; stdcall; external kernel32 name 'GetProcessPriorityBoost';
function SetProcessPriorityBoost(hThread: THandle; DisablePriorityBoost: Bool): BOOL; stdcall;  external kernel32 name 'SetProcessPriorityBoost';
function GetProcessAffinityMask(hProcess: THandle; var lpProcessAffinityMask, lpSystemAffinityMask: DWORD): BOOL; stdcall;  external kernel32 name 'GetProcessAffinityMask';
function SetProcessAffinityMask(hProcess: THandle; dwProcessAffinityMask: DWORD): BOOL; stdcall;  external kernel32 name 'SetProcessAffinityMask';

implementation

type
   TGetProcessMemoryInfo = function (hProcess: THandle; ppsmemCounters: PPROCESS_MEMORY_COUNTERS; cb: DWORD): BOOL; stdcall;
   TZwOpenProcess = function(phProces: PDWORD; AccessMask: DWORD; ObjectAttributes: PObjectAttributes; ClientID: PClientID): NTStatus; stdcall;
   TZwQueryInformationProcess = function(hProcess: THandle; InformationClass: DWORD; Buffer: PChar{PPROCESS_BASIC_INFORAMTION}; BufferLength : DWORD;ReturnLength: PDWORD): DWORD; stdcall;
   TGetSecurityInfo = function(Handle: THandle; ObjectType: DWORD; SecurityInfo: DWORD; ppsidOwner, ppsidGroup: PPSID;
                               ppDacl, ppSacl: PPACL; var ppSecurityDescriptor:  PSecurityDescriptor): DWORD; stdcall;

var
   hPSAPI: THandle;
   hNTDLL: THandle;
   hADVAP: THandle;
   ZwOpenProcess: TZwOpenProcess;
   ZwQueryInformationProcess: TZwQueryInformationProcess;
   GetProcessMemoryInfo: TGetProcessMemoryInfo;
   GetSecurityInfo: TGetSecurityInfo;

procedure SetDebugPrivilege(Enabled : Boolean);
var
  hToken: THandle;
  TokenPriv, PrevTokenPriv: TOKEN_PRIVILEGES;
  Tmp: Cardinal;
begin
  OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken);
  LookupPrivilegeValue(nil, 'SeDebugPrivilege', TokenPriv.Privileges[0].Luid);
  TokenPriv.PrivilegeCount := 1;
  TokenPriv.Privileges[0].Attributes := 0;
  if Enabled then TokenPriv.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
  Tmp := 0;
  PrevTokenPriv := TokenPriv;
  AdjustTokenPrivileges(hToken, False, TokenPriv, SizeOf(PrevTokenPriv), PrevTokenPriv, Tmp);
  CloseHandle(hToken);
end;

function GetProcessAccount(proc: THandle) : string;
const
  SE_KERNEL_OBJECT = 6;
var
  sd: PSecurityDescriptor;
  snu: SID_NAME_USE;
  DomainName, UserName: PChar;
  UserNameSize, DomainNameSize: cardinal;
  sid: PSid;
begin
  Result := '';
  if GetSecurityInfo(proc, SE_KERNEL_OBJECT, OWNER_SECURITY_INFORMATION, @sid, nil, nil, nil, sd) = ERROR_SUCCESS then
  begin
    UserNameSize := 1024; GetMem(UserName, UserNameSize);
    DomainNameSize := 1024; GetMem(DomainName, DomainNameSize);
    if LookupAccountSid(nil, sid, UserName, UserNameSize, DomainName, DomainNameSize, snu) then Result := UpperCase(DomainName);
    if Result = 'BUILTIN' then Result := 'SYSTEM' else Result := UserName;  
    LocalFree(Integer(sd));
    FreeMem(UserName);
    FreeMem(DomainName);
  end;
end;

function TerminateApp(ProcessID: DWORD; Timeout: DWORD): Integer;
var
  ProcessHandle: THandle;

  function EnumWindowsProc(Wnd: HWND; ProcessID: DWORD): Boolean; stdcall;
  var
    PID: DWORD;
  begin
    GetWindowThreadProcessId(Wnd, @PID);
    if ProcessID = PID then
      PostMessage(Wnd, WM_CLOSE, 0, 0);
    Result := True;
  end;

begin
  Result := -1;
  if ProcessID <> GetCurrentProcessId then
  begin
    ProcessHandle := OpenProcess(SYNCHRONIZE or PROCESS_TERMINATE, False, ProcessID);
  TRY
    if ProcessHandle <> 0 then
    begin
      EnumWindows(@EnumWindowsProc, LPARAM(ProcessID));
      if WaitForSingleObject(ProcessHandle, Timeout) = WAIT_OBJECT_0 then Result := 0
      else if TerminateProcess(ProcessHandle, 1) then Result := 1;
    end;
  FINALLY
    CloseHandle(ProcessHandle);
  END;
  end;
end;

constructor ThiEnumProcess.Create;
begin
  inherited;
  FillChar(ovi, SizeOf(TOSVersionInfo), #0); 
  ovi.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  GetVersionEx(ovi);
  if hPSAPI = 0 then
  begin
    hPSAPI := LoadLibrary('PSAPI.dll');
    @GetProcessMemoryInfo   := GetProcAddress(hPSAPI, 'GetProcessMemoryInfo');
  end;
  if hNTDLL = 0 then
  begin
    hNTDLL := LoadLibrary('ntdll.dll');
    @ZwOpenProcess :=  GetProcAddress(hNTDLL, 'ZwOpenProcess');
    @ZwQueryInformationProcess := GetProcAddress(hNTDLL, 'ZwQueryInformationProcess');
  end;
  if hADVAP = 0 then
  begin
    hADVAP := LoadLibrary('advapi32.dll');
    @GetSecurityInfo :=  GetProcAddress(hADVAP, 'GetSecurityInfo');
  end;   
end;

procedure ThiEnumProcess._work_doKill;
var
  proc: THandle;
begin
  SetDebugPrivilege(DebugPrivilege);
  proc := OpenProcess(PROCESS_TERMINATE,true,procEntry.th32ProcessID);
  TerminateProcess(proc, 1);
  CloseHandle(proc);
end;

procedure ThiEnumProcess._work_doTerminateApp;
begin
  SetDebugPrivilege(DebugPrivilege);
  _hi_onEvent(_event_onTerminateApp, TerminateApp(procEntry.th32ProcessID, _prop_TimeOut)); 
end;

function Trim(const Str : string): string;
var
  L: integer;
begin
  Result := Str;
  L := Length(Result);
  while (L > 0) and (Result[L] <= ' ') do Dec(L);
  SetLength(Result, L);
  L := 1;
  while (L <= Length(Result)) and (Result[L] <= ' ') do Inc(L);
  Result := string(PChar(integer(@Result[1]) + L - 1)); 
end;

function WideStringToString(const ws: WideString): String;
var
  l: integer;
begin
  if ws = '' then
    Result := ''
  else
  begin
    l := WideCharToMultiByte(CP_ACP, WC_COMPOSITECHECK or WC_DISCARDNS or WC_SEPCHARS or WC_DEFAULTCHAR, PWChar(ws), -1, nil, 0, nil, nil);
    SetLength(Result, l - 1);
    if l > 1 then
      WideCharToMultiByte(CP_ACP, WC_COMPOSITECHECK or WC_DISCARDNS or WC_SEPCHARS or WC_DEFAULTCHAR, PWChar(ws), -1, PChar(Result), l - 1, nil, nil);
  end;
end;

procedure ThiEnumProcess.EnumNT;
const
  INCREMENTAL_SIZE     = 32768; //   
  INITIAL_BUFFER_SIZE  = 65536; //   
  PROCESS_OBJECT_INDEX = 230;   //   Process
  PID_OBJECT_INDEX     = 784;   //   ID Process (PID)

var
  hProcess: THandle;
  DeviceList: PStrListEx;
  S: DWORD;
  buflen: DWORD; //   
  PerfData: PPerfDataBlock; // PERF_DATA_BLOCK
  PerfObj: PPerfObjectType; // PERF_OBJECT_TYPE
  PerfCntr, CurCntr: PPerfCounterDefinition;  // PERF_COUNTER_DEFINITION
  PerfInst: PPerfInstanceDefinition;  // PERF_INSTANCE_DEFINITION
  PerfCntrBlk, PtrToCntr: PPerfCounterBlock;   // PERF_COUNTER_BLOCK
  i,k,j: Integer; //   
  process_name: String; //  
  pData: PLargeInteger; //    
  OA: TObjectAttributes;
  CID: TClientID;
  path, pathstr: string;    
  dev: string;
  
(*
  function GetDeviceName(NTDevice: string): string;
  var
    Root: string; 
    DeviceName: string; 
    Drives: DWORD;
    len: integer;
  begin
    Result := '';
    Drives := GetLogicalDrives();
    Root := 'A:';
    while Drives <> 0 do
    begin 
      if (Drives and 1) = 1 then
      begin 
        SetLength(DeviceName, 256); 
        len := QueryDosDevice(@Root[1], @DeviceName[1], 256);
        if len <> 0 then
        begin 
          SetLength(DeviceName, len);
          if Trim(DeviceName) = Trim(NTDevice) then
          begin
            Result := string(Root) + '\';
            break;
          end;    
        end;  
      end;
      inc(Root[1]); 
      Drives:= Drives shr (1); 
    end;
  end;    
*)
  procedure GetDeviceList(List: PStrListEx);
  var
    Root: string; 
    DeviceName: string; 
    Drives: DWORD;
    len: integer;
  begin
    Drives := GetLogicalDrives();
    Root := 'A:';
    while Drives <> 0 do
    begin 
      if (Drives and 1) = 1 then
      begin 
        SetLength(DeviceName, 256); 
        len := QueryDosDevice(@Root[1], @DeviceName[1], 256);
        if len <> 0 then
        begin 
          SetLength(DeviceName, len);
          DeviceList.AddObject(Trim(DeviceName), ord(Root[1]));
        end;  
      end;
      inc(Root[1]); 
      Drives:= Drives shr (1); 
    end;    
  end;

  function GetDeviceName(NTDevice: string): string;
  var
    ii, jj: integer;
  begin
    for ii := 0 to DeviceList.Count - 1 do
    begin
      if DeviceList.Items[ii] = Trim(NTDevice) then
      begin
        jj := DeviceList.Objects[ii]; 
        Result := char(jj) + ':\';
        break;
      end;
    end; 
  end;
  
begin
  buflen := INITIAL_BUFFER_SIZE;
  DeviceList := NewStrListEx;
  GetDeviceList(DeviceList);  
  //   
  GetMem(PerfData, buflen);
TRY
  //    
  while RegQueryValueEx(HKEY_PERFORMANCE_DATA, PChar(Int2Str(PROCESS_OBJECT_INDEX)),
                        nil, nil, Pointer(PerfData), @buflen) = ERROR_MORE_DATA do
  begin
    //   ,      
    inc(buflen, INCREMENTAL_SIZE);
    ReallocMem(PerfData, buflen);
  end;
  RegCloseKey(HKEY_PERFORMANCE_DATA); //    .
  //      PERF_OBJECT_TYPE ( )
  PerfObj := PPerfObjectType(DWORD(PerfData) + PerfData.HeaderLength);
  //     
  for i := 0 to PerfData.NumObjectTypes - 1 do
  begin
    //   Process ( 230)
    if PerfObj.ObjectNameTitleIndex = PROCESS_OBJECT_INDEX then
    begin
      //     PERF_COUNTER_DEFINITION
      PerfCntr := PPerfCounterDefinition(DWORD(PerfObj) + PerfObj.HeaderLength);
      //    Process,   
      if PerfObj.NumInstances > 0 then
      begin
        //      PERF_INSTANCE_DEFINITION
        PerfInst := PPerfInstanceDefinition(DWORD(PerfObj) + PerfObj.DefinitionLength);
        //    
        for k := 0 to PerfObj.NumInstances - 1 do
        begin
          //     ( )
          process_name := Trim(WideCharToString(PWideChar(DWORD(PerfInst) + PerfInst.NameOffset)));
          //    '_Total',    
          // ..      
          if process_name = '_Total' then Continue;
          //      PERF_COUNTER_DEFINITION
          CurCntr := PerfCntr;
          //        PERF_COUNTER_BLOCK
          PtrToCntr := PPerfCounterBlock(DWORD(PerfInst) + PerfInst.ByteLength);
          //     
          for j := 0 to PerfObj.NumCounters - 1 do
          begin
            //     
            pData := Pointer(DWORD(PtrToCntr) + CurCntr.CounterOffset);
            //   -  ID Process,        
            if CurCntr.CounterNameTitleIndex = PID_OBJECT_INDEX then
            begin
              FillChar(OA, SizeOf(OA), #0);
              CID.UniqueThread:=0;
              CID.UniqueProcess := Integer(pData^);
              hProcess := 0;
              pathstr := '';
              if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) = NO_ERROR then
              begin
                ZwQueryInformationProcess(hProcess, PROCESS_IMAGE_FILE_NAME, nil, 0, @buflen);
                setLength(path, buflen);
                ZwQueryInformationProcess(hProcess, PROCESS_IMAGE_FILE_NAME, @path[1], buflen, @buflen);
                pathstr := WideCharToString(PWideChar(@path[1])) + #0;
                ZwQueryInformationProcess(hProcess, PROCES_WOW64_INFORMATION, @S, SizeOf(S), @buflen);
                if S <> 0 then
                  process_name := process_name + ' *32';

                Delete(pathstr, 1, 5);
                dev := '\' + GetTok(pathstr, '\') + '\';
                dev := dev + GetTok(pathstr, '\');
                pathstr := GetDeviceName(dev) + pathstr;

              end;  
              CloseHandle(hProcess);
              FillChar(procEntry.szExeFile, SizeOf(procEntry.szExeFile), #0); 
              if pathstr = '' then
                Move(process_name[1], procEntry.szExeFile, length(process_name))
              else
                Move(pathstr[1], procEntry.szExeFile, length(pathstr));

              procEntry.th32ProcessID := Integer(pData^);
              if not CallBack() then exit;
            end;
            //     
            CurCntr := PPerfCounterDefinition(DWORD(CurCntr) + CurCntr.ByteLength); 
          end;  
          //      
          //       
          PerfCntrBlk := PPerfCounterBlock(DWORD(PerfInst) + PerfInst.ByteLength);
          PerfInst := PPerfInstanceDefinition(DWORD(PerfCntrBlk) + PerfCntrBlk.ByteLength);
        end;
      end;
    end;
    //      
    PerfObj := PPerfObjectType(DWORD(PerfObj) + PerfObj.TotalByteLength);
  end;
FINALLY
  //     ,  
  DeviceList.free;
  FreeMem(PerfData);
  _hi_OnEvent(_event_onEndEnum);
END;
end;

procedure ThiEnumProcess.Enum;
begin
  SetDebugPrivilege(DebugPrivilege);
  if ovi.dwMajorVersion < 5 then exit;
  EnumNT(CallBack);
end;

function ThiEnumProcess.EnumAll;
begin
  if procEntry.szExeFile <> '' then
    _hi_OnEvent( _event_onProcess, procEntry.szExeFile );
  Result := true;
end;

procedure ThiEnumProcess._work_doEnum;
begin
  Enum(EnumAll);
  FillChar(procEntry, sizeof(procEntry), 0);
end;

procedure ThiEnumProcess._work_doDebugPrivilege;
begin
  DebugPrivilege := ReadBool(_Data);
end;

function ThiEnumProcess.FindID;
begin
  Result := ID <> procEntry.th32ProcessID;
end;

procedure ThiEnumProcess._work_doFindID;
begin
  ID := ReadInteger(_Data, _data_ID, 0);
  Enum(FindID);
  if ID = procEntry.th32ProcessID then
  begin
    FFullPath := procEntry.szExeFile;
    _hi_CreateEvent(_Data, @_event_onFind);
  end   
  else
  begin
    FFullPath := '';
    _hi_CreateEvent(_Data, @_event_onNotFind);
  end;
end;

function ThiEnumProcess.FindName;
begin
  Result := PName <> ExtractFileName(LowerCase(procEntry.szExeFile));
end;

procedure ThiEnumProcess._work_doFindName;
begin
  PName := LowerCase(ReadString(_Data,_data_Name,_prop_Name));
  Enum(FindName);
  if PName = ExtractFileName(LowerCase(procEntry.szExeFile)) then
  begin
    FFullPath := procEntry.szExeFile; 
    _hi_CreateEvent(_Data,@_event_onFind);
  end   
  else
  begin
    FFullPath := '';
    _hi_CreateEvent(_Data,@_event_onNotFind);
  end;   
end;

procedure ThiEnumProcess._work_doGetPriority;
var
  proc: THandle;
  pc: Cardinal;
begin
  SetDebugPrivilege(DebugPrivilege);
  proc := OpenProcess(PROCESS_QUERY_INFORMATION, true, procEntry.th32ProcessID);
  pc:= integer(GetPriorityClass(proc));
  case pc of
    NORMAL_PRIORITY_CLASS       : _hi_OnEvent(_event_onGetPriority, 0);
    IDLE_PRIORITY_CLASS         : _hi_OnEvent(_event_onGetPriority, 1);
    HIGH_PRIORITY_CLASS         : _hi_OnEvent(_event_onGetPriority, 2);
    REALTIME_PRIORITY_CLASS     : _hi_OnEvent(_event_onGetPriority, 3);
    BELOW_NORMAL_PRIORITY_CLASS : _hi_OnEvent(_event_onGetPriority, 4);
    ABOVE_NORMAL_PRIORITY_CLASS : _hi_OnEvent(_event_onGetPriority, 5);
  end;
  CloseHandle(proc);
end;

procedure ThiEnumProcess._work_doGetProc;
var
  proc: THandle;
  lpProcessAffinityMask, lpSystemAffinityMask: dword;
begin
  SetDebugPrivilege(DebugPrivilege);
  proc := OpenProcess(PROCESS_QUERY_INFORMATION, true, procEntry.th32ProcessID);
  GetProcessAffinityMask(proc, lpProcessAffinityMask, lpSystemAffinityMask);
  _hi_CreateEvent(_Data, @_event_onGetProc, {$ifdef F_P}integer{$endif}(lpProcessAffinityMask));
  CloseHandle(proc);
end;

procedure ThiEnumProcess._work_doGetMemoryInfo;
var
  proc: THandle;
  pmc: TProcessMemoryCounters;
begin
  SetDebugPrivilege(DebugPrivilege);
  proc := OpenProcess(PROCESS_ALL_ACCESS, true, procEntry.th32ProcessID);
  if GetProcessMemoryInfo(proc, @pmc, sizeof(TProcessMemoryCounters)) then
    _hi_CreateEvent(_Data, @_event_onGetMemoryInfo, {$ifdef F_P}integer{$endif}(pmc.WorkingSetSize));
  CloseHandle(proc);
end;

procedure ThiEnumProcess._work_doGetProcessAccount;
var
  proc: THandle;
begin
  SetDebugPrivilege(DebugPrivilege);
  proc := OpenProcess(PROCESS_ALL_ACCESS, true, procEntry.th32ProcessID);
  _hi_CreateEvent(_Data,@_event_onGetProcessAccount, GetProcessAccount(proc));
  CloseHandle(proc);
end;

procedure ThiEnumProcess._work_doGetProcBoost;
var
  proc: THandle;
  DisablePriorityBoost: Bool;
begin
  SetDebugPrivilege(DebugPrivilege);
  proc := OpenProcess(PROCESS_QUERY_INFORMATION, true, procEntry.th32ProcessID);
  GetProcessPriorityBoost(proc, DisablePriorityBoost);
  if DisablePriorityBoost then
    _hi_CreateEvent(_Data, @_event_onGetProcBoost, 0)
  else
    _hi_CreateEvent(_Data, @_event_onGetProcBoost, 1);
  CloseHandle(proc);
end;

procedure ThiEnumProcess._work_doSetPriority;
var
  proc: THandle;
  pc: cardinal;
begin
  SetDebugPrivilege(DebugPrivilege);
  proc := OpenProcess(PROCESS_SET_INFORMATION, true, procEntry.th32ProcessID);
  case Readinteger(_Data, _data_PriorityClass, 0) of
    0: pc := NORMAL_PRIORITY_CLASS;
    1: pc := IDLE_PRIORITY_CLASS;
    2: pc := HIGH_PRIORITY_CLASS;
    3: pc := REALTIME_PRIORITY_CLASS;
    4: pc := BELOW_NORMAL_PRIORITY_CLASS;
    5: pc := ABOVE_NORMAL_PRIORITY_CLASS;
    else pc := NORMAL_PRIORITY_CLASS;
  end;
  SetPriorityClass(proc, pc);
  CloseHandle(proc);
end;

procedure ThiEnumProcess._work_doSetProc;
var
  proc: THandle;
  pc: byte;
begin
  pc := Readinteger(_Data,_data_AffinityMask,0);
  if pc = 0 then Exit;
  SetDebugPrivilege(DebugPrivilege);
  proc := OpenProcess(PROCESS_SET_INFORMATION, true, procEntry.th32ProcessID);
  SetProcessAffinityMask(proc, pc);
  CloseHandle(proc);
end;

procedure ThiEnumProcess._work_doSetProcBoost;
var
  proc: THandle;
  pc: byte;
  DisablePriorityBoost:bool;
begin
  pc := Readinteger(_Data,_data_PriorityBoost,0);
  DisablePriorityBoost := not boolean(pc);
  SetDebugPrivilege(DebugPrivilege);
  proc := OpenProcess(PROCESS_SET_INFORMATION, true, procEntry.th32ProcessID);
  SetProcessPriorityBoost(proc, DisablePriorityBoost);
  CloseHandle(proc);
end;

procedure ThiEnumProcess._var_CurrentID;
begin
  dtInteger(_Data, procEntry.th32ProcessID);
end;

procedure ThiEnumProcess._var_CurrParentID;
var
  Info: PROCESS_BASIC_INFORMATION;  
  hProcess: DWORD;
  OA: TObjectAttributes;
  CID: TClientID;
  Result: integer;
begin
  SetDebugPrivilege(DebugPrivilege);
  FillChar(Info, SizeOf(Info), #0);
  FillChar(OA, SizeOf(OA), #0);
  CID.UniqueThread := 0;
  CID.UniqueProcess := procEntry.th32ProcessID;
  hProcess := 0;
  Result := 0;
  if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) = NO_ERROR then
    if ZwQueryInformationProcess(hProcess, 0, @Info, SizeOf(Info), nil) = NO_ERROR then
      Result := Info.uInheritedFromUniqueProcessId;
  dtInteger(_Data, Result);
  CloseHandle(hProcess);
end;

procedure ThiEnumProcess._var_FileName;
begin
  dtString(_Data, procEntry.szExeFile);
end;

procedure ThiEnumProcess._var_CPUCount;
var
  lpSystemInfo: _SYSTEM_INFO;
begin
  GetSystemInfo(lpSystemInfo);
  dtInteger(_Data, lpSystemInfo.dwNumberOfProcessors);
end;

procedure ThiEnumProcess._var_FullPath;
begin
  dtString(_Data, FFullPath);
end;

procedure ThiEnumProcess._var_Release;
begin
  dtString(_Data, RELEASE_COMPONENT + ';   WinVersion: ' + int2str(ovi.dwMajorVersion) + '.' + int2str(ovi.dwMinorVersion));
end;

end.